<template>
  <SinglePane>
    <ObLoader
      :size="80"
      :delay="1000"
      :class="[ 'scenario-loader', { 'hidden': !scenarioPending } ]"
    />

    <div class="scenario-header">
      <div class="scenario-info">
        <button
          type="button"
          class="back-button"
          @click="onGoBack"
        >
          <i class="icon chevron-left back-button__icon" />

          {{ tenderInfo.number }} {{ tenderInfo.title }}
        </button>

        <div class="scenario-name">
          <span class="scenario-code">Сценарий.</span> {{ scenario.title || '—'  }}
        </div>

        <div class="scenario-description">
          {{ scenario.description || '—'  }}
        </div>
      </div>

      <div class="scenario-actions">
        <div
          v-if="scenario.variantStatus === 'WINNER'"
          class="badge"
        >
          <i class="icon checked badge__icon" /> Выбран итоговым
        </div>

        <ObButton
          v-else-if="scenario.scenarioStatus === 'DRAFT'"
          label="Сохранить как..."
          type="outline"
          @click="$refs['save-modal'].open()"
        />

        <TmsPolicy
          v-if="scenario.variantStatus === 'WINNER' && ['SUMMARIZING', 'COMPLETED'].includes(tenderInfo.status)"
          :tender="tenderInfo"
        />
      </div>
    </div>

    <Options
      :tender-uuid="tenderUuid"
      :scenario-uuid="scenarioUuid"
      @recalculate-scenario="onRecalculateScenario"
    />

    <ObTable
      ref="results-table"
      :columns="columns"
      :remote-opt="{
        method: getResultsByFilterTab,
        arguments: {
          tenderUuid,
          scenarioUuid
        },
        contentKey: getRequestContentKey
      }"
      :functional-panel="true"
      :table-layout-fixed="false"
      :show-hidden-length="true"
      :filter-buttons="filterButtons"
      :is-functional-sort="false"
      :is-functional-group="false"
      :is-functional-search="false"
      :class="[ 'results-table', `filter-${viewFilter}` ]"
      :filters-handler="filtersHandler"
      @on-change-filter-button="onChangeFilterButton"
      @on-load-list="onTableDataLoaded"
      @select="onSelect"
    >
      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>
    </ObTable>

    <InfoBar :source="lots" />

    <DataModal
      v-if="selectedData"
      ref="lots-modal"
      :title="viewFilterModalTitle"
      :view-filter="viewFilter"
      :remote-opts="{
        method: api.tendersScenarios.getTenderScenarioOffersByUuidsAndLot,
        arguments: {
          tenderUuid,
          scenarioUuid,
          lotUuid: selectedData.lotUuid
        },
        contentKey: 'carriers'
      }"
    >
      <div class="modal-heading">Индикатор дефицита: <span>{{ selectedData.deficitIndicator }}</span></div>
      <div class="modal-heading">Вес лота: <span>{{ selectedData.lotWeight }}</span></div>
      <div class="modal-heading">Min ставка: <span>{{ selectedData.minBid }} ₽</span></div>
      <div class="modal-heading">Max ставка: <span>{{ selectedData.maxBid }} ₽</span></div>
      <div class="modal-heading">Выбрано пост-ков: <span>{{ selectedData.carrierCount }}</span></div>
      <div class="modal-heading">Затраты: <span>{{ selectedData.lotCost }} ₽</span></div>
    </DataModal>

    <DataModal
      v-if="selectedData"
      ref="contractors-modal"
      :title="viewFilterModalTitle"
      :view-filter="viewFilter"
      :remote-opts="{
        method: api.tendersScenarios.getTenderScenarioOffersByUuidsAndCarrier,
        arguments: {
          tenderUuid,
          scenarioUuid,
          carrierUuid: selectedData.uuid
        },
        contentKey: 'variantValues'
      }"
    >
      <div class="modal-heading">Квота во всех лотах: <span>{{ selectedData.carriageQuoteSum }}</span></div>
      <div class="modal-heading">Сумма затрат на все лоты: <span>{{ selectedData.costSum }} ₽</span></div>
      <div class="modal-heading">Доля в общ. объеме: <span>{{ selectedData.partInTotalVolume }} %</span></div>
      <div class="modal-heading">Доля в общ. затратах: <span>{{ selectedData.partInTotalCosts }} %</span></div>
    </DataModal>

    <SaveModal
      ref="save-modal"
      :tender-uuid="tenderUuid"
      :scenario-uuid="scenarioUuid"
      @go-to-scenarios="goToScenarios"
    />

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </SinglePane>
</template>

<script>
  import { scenario_columns } from "./data.js";
  import { mapGetters, mapActions } from "vuex";

  import api from "@/api";
  import { uuid } from "vue-uuid";
  import ExportExcel from "../tabs/mixins/export-excel";
  import FiltersSupport from "../../mixins/filtersSupport";
  import Options from "./components/options";
  import DataModal from "./components/dataModal";
  import SaveModal from "./components/saveModal";
  import TmsPolicy from "../components/tmsPolicy";
  import InfoBar from "../components/infoBar";

  import SinglePane from "common-components/src/obComponents/obSinglePanels";
  import ObTable from "common-components/src/obComponents/obTable";
  import ObButton from "common-components/src/obComponents/obButton";
  import ObLoader from "common-components/src/obComponents/obLoader";
  import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";

  export default {
    name: "tender-scenario",
    mixins: [
      ExportExcel,
      FiltersSupport
    ],
    components: {
      SinglePane,
      ObTable,
      ObButton,
      ObLoader,
      ObMenuDropdown,
      Options,
      DataModal,
      SaveModal,
      TmsPolicy,
      InfoBar
    },
    computed: {
      ...mapGetters({
        scenario: "tendersScenario/scenario",
        tenderInfo: "tendersScenario/tenderInfo",
        initialParams: "tendersScenario/initialParams",
        contractorsCount: "tendersScenario/contractorsCount",
        isOptionsDisabled: "tendersScenario/isOptionsDisabled"
      }),
      tenderUuid: ({ $route }) => $route.params.uuid,
      scenarioUuid: ({ $route }) => $route.params.scenarioUuid,
      getRequestContentKey: ({ viewFilter }) => {
        switch (viewFilter) {
          case "all":
            return "variantValues"
          case "lots":
            return "variantsByLots"
          case "contractors":
            return "carriers"
        }
      },
      scenarioParams: {
        get () {
          return this.$store.state.tendersScenario.scenario.params
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setParams", value)
        }
      },
      options: {
        get () {
          return this.$store.state.tendersScenario.options
        },
        set (value) {
          this.$store.dispatch("tendersScenario/setOptions", value)
        }
      }
    },
    data() {
      return {
        api,
        viewFilter: null,
        columns: [],
        lots: [],
        filterButtonWasChanged: null,
        filterButtons: [
          {
            title: "Все предложения",
            relates: "all"
          },
          {
            title: "По лотам",
            relates: "lots"
          },
          {
            title: "По поставщикам",
            relates: "contractors"
          }
        ],
        selectedData: null,
        viewFilterModalTitle: "",
        scenarioPending: false
      }
    },
    created() {
      // If user want to visit another one scenario, need to reset
      // information and options from previous scenario
      this.resetState();

      this.createdMethods();
    },
    watch: {
      scenarioParams: {
        deep: true,
        handler(params) {
          if (
            params.CONTRACTOR_VOLUME_LIMIT_PER_LOT_FROM !== "" ||
            params.CONTRACTOR_VOLUME_LIMIT_PER_LOT_TO !== "" ||
            params.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_FROM !== "" ||
            params.CONTRACTOR_VOLUME_LIMIT_PER_PURCHASE_TO !== ""
          ) {
            params.ACCOUNT_GUARANTEED_VOLUMES = true;
          }
        }
      }
    },
    methods: {
      ...mapActions({
        initScenario: "tendersScenario/initScenario",
        resetState: "tendersScenario/resetState"
      }),
      async createdMethods() {
        await this.initScenario({ tenderUuid: this.tenderUuid, scenarioUuid: this.scenarioUuid });

        this.onChangeFilterButton({ relates: "all" });
      },
      getResultsByFilterTab(args) {
        switch (this.viewFilter) {
          case "all":
            return api.tendersScenarios.getTenderScenarioResultsByUuids({ ...args, ...this.tableParameters });
          case "lots":
            return api.tendersScenarios.getTenderScenarioResultsByUuidsAndLots({ ...args, ...this.tableParameters });
          case "contractors":
            return api.tendersScenarios.getTenderScenarioResultsByUuidsAndCarriers({ ...args, ...this.tableParameters });
          default: // While "viewFilter" is not initialized in "createdMethods"
            return () => {}
        }
      },
      loadData(refName, init = true) {
        this.$nextTick(() => this.$refs[refName].loadData({ init }))
      },
      goToScenarios () {
        this.$router.push({ path: `/tenders/${this.tenderUuid}/scenarios`, query: { ...this.$route.query } })
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.scenario(this.tenderUuid, this.scenarioUuid)
      },
      // 👂 Events
      onGoBack() {
        if (this.scenario.scenarioStatus === "DRAFT") {
          this.$refs["save-modal"].open(true);
        } else {
          this.goToScenarios()
        }
      },
      async onRecalculateScenario() {
        this.scenarioPending = true;

        const generatedUuid = uuid.v4();

        const payload = {
          tenderUuid: this.tenderUuid,
          scenarioUuid: generatedUuid,
          scenarioTitle: this.scenario.title,
          scenarioDescription: this.scenario.description,
          params: []
        }

        if (!this.scenarioParams.DEVIATION_TYPE) {
          // Deleting deviation from/to if empty type
          this.scenarioParams.DEVIATION_PER_LOT_FROM = "";
          this.scenarioParams.DEVIATION_PER_LOT_TO = "";
        }

        Object.entries(this.scenarioParams).forEach(entry => {
          // Deleting empty array params
          if (entry[0] === "CONTRACTOR_FILTER"|| entry[0] === "REJECT_DEVIATIONS"|| entry[0] === "INCLUDED_DEVIATIONS") {
            if (entry[1].length) {
              payload.params.push({ code: entry[0], value: entry[1] });
            }
          // Deleting empty number/strings params
          } else if ((typeof entry[1] === "number" && entry[1] !== "") || entry[1]) {
            payload.params.push({ code: entry[0], value: entry[1] });
          }
        })

        const recalculation = await api.tendersScenarios.recalculateTenderScenario(payload);

        if (recalculation?.error) {
          this.scenarioPending = false;

          this.$notification({
            type: "system_notification_error",
            message: `Ошибка: ${recalculation.details}`
          })
        } else {
          const interval = setInterval(async () => {
            const response = await api.tendersScenarios.getTenderScenarioByUuids(this.tenderUuid, generatedUuid);

            if (response.scenario.variantUuid) {
              clearInterval(interval);
              this.scenarioPending = false;
              this.$router.push({ path: `/tenders/${this.tenderUuid}/scenario/${generatedUuid}` });
              this.createdMethods();
            }
          }, 3000);
        }

      },
      onChangeFilterButton({ relates }) {
        this.filterButtonWasChanged = this.viewFilter !== relates;
        this.viewFilter = relates;

        const table = this.$refs["results-table"]

        if (table && table.$children[1]) {
          table.$children[1].sort.key = null;
          table.$children[1].sort.type = null;
        }

        this.loadData("results-table");
      },
      onSelect(e) {
        this.selectedData = e;

        switch(this.viewFilter) {
          case "lots":
            this.viewFilterModalTitle = `${e.number}. ${e.fromPlaceTitle} → ${e.toPlaceTitle} / ${e.resourceTypeTitle} / ${e.carriageCount}`;

            this.$nextTick(() => this.$refs["lots-modal"].open());

            break;

          case "contractors":
            this.viewFilterModalTitle = e.title;

            this.$nextTick(() => this.$refs["contractors-modal"].open());

            break;
        }
      },
      async onTableDataLoaded(data) {
        if (data) {
          this.lots = data
        }

        if (this.filterButtonWasChanged) {
          this.filterButtonWasChanged = false;

          this.columns = [...scenario_columns[this.viewFilter]];

          const dynamicColumns = this.$refs["results-table"].localItems[0]?.lotHeaders;

          if (dynamicColumns && dynamicColumns.length) {
            const lotHeaders = dynamicColumns
              .sort((a,b) => a.categoryPos - b.categoryPos || a.pos - b.pos)
              .map(header => {
                return {
                  title: header.title,
                  headerHtml: () => `<div class="text-gray">${header.categoryTitle}</div>${header.title}`,
                  key: header.uuid,
                  isAlignRight: typeof header.value === 'number',
                  html: (data) => data.lotHeaders.find(h => h.uuid === header.uuid).value
                }
              })

            this.columns.splice(5, 0, ...lotHeaders);
          }
        }

        // For tables "by lots" and "by carriers"
        if (this.viewFilter === "all") {
          return
        }

        setTimeout(() => {
          this.$refs["results-table"].selectableItems.forEach((item) => {
            if (
              this.viewFilter === "lots" && (item.item.deficitIndicator || !item.item.lotCost) ||
              this.viewFilter === "contractors" && (item.item.deficitLotsCount || !item.item.costSum)
            ) {
              this.$set(item, "_isSelected", true)
            }
          })
        }, 0)
      },
      reloadTable () {
        this.loadData('results-table')
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  /deep/ .text-gray {
    color: $color-grey-span;
  }

  .scenario-loader {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: rgba($background-black, .3);
    z-index: 1000;
    transition: opacity .5s ease;
    display: flex;
    justify-content: center;
    align-items: center;

    &.hidden {
      opacity: 0;
      pointer-events: none;
    }
  }

  .scenario-header {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    padding: 26px 20px 0;
  }

  .scenario-info {
    max-width: 1000px;
    margin-right: 50px;

    .back-button {
      @include font-mixin(14px, 18px, 400, $color-blue-navy-blue);

      border: none;
      background: none;
      cursor: pointer;
      margin-bottom: 10px;
      display: flex;
      align-items: center;

      &:hover,
      &:focus {
        outline: none;
        color: $blue-800;
      }

      &__icon {
        font-size: 24px;
        margin-right: 10px;
      }
    }
  }

  .scenario-actions {
    margin-top: 35px;
    display: grid;
    grid-auto-flow: column;
    grid-column-gap: 20px;
  }

  .scenario-name {
    @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);

    padding-left: 34px;
  }

  .scenario-code {
    color: $color-grey-span;
  }

  .scenario-description {
    @include font-mixin(14px, 18px, 400, $gray-slate);

    padding-left: 34px;
  }

  .scenario-sum-prices {
    font-weight: bold;
    margin-left: 40px;
  }

  .modal-heading {
    @include font-mixin(14px, 18px, 400, $gray-slate);

    margin-right: 30px;

    span {
      color: $tendersPage-modal_heading_span;
    }
  }

  .badge {
    color: $green-800;
    display: flex;
    align-items: center;

    &__icon {
      color: $Green-700;
      font-size: 17px;
      margin-right: 6px;
      font-weight: bold;
    }
  }

  .results-table {
    &.filter-all::v-deep .data-row {
      cursor: auto;
    }

    ::v-deep {
      tr.row-selected {
        background-color: rgba($gorse-yellow, .1);
      }
    }
  }
</style>
